Index: test/max_matching_test.cc
===================================================================
--- test/max_matching_test.cc	(revision 440)
+++ test/max_matching_test.cc	(revision 440)
@@ -0,0 +1,310 @@
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library.
+ *
+ * Copyright (C) 2003-2009
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#include <iostream>
+#include <sstream>
+#include <vector>
+#include <queue>
+#include <lemon/math.h>
+#include <cstdlib>
+
+#include <lemon/max_matching.h>
+#include <lemon/smart_graph.h>
+#include <lemon/lgf_reader.h>
+
+#include "test_tools.h"
+
+using namespace std;
+using namespace lemon;
+
+GRAPH_TYPEDEFS(SmartGraph);
+
+
+const int lgfn = 3;
+const std::string lgf[lgfn] = {
+  "@nodes\n"
+  "label\n"
+  "0\n"
+  "1\n"
+  "2\n"
+  "3\n"
+  "4\n"
+  "5\n"
+  "6\n"
+  "7\n"
+  "@edges\n"
+  "     label  weight\n"
+  "7 4  0      984\n"
+  "0 7  1      73\n"
+  "7 1  2      204\n"
+  "2 3  3      583\n"
+  "2 7  4      565\n"
+  "2 1  5      582\n"
+  "0 4  6      551\n"
+  "2 5  7      385\n"
+  "1 5  8      561\n"
+  "5 3  9      484\n"
+  "7 5  10     904\n"
+  "3 6  11     47\n"
+  "7 6  12     888\n"
+  "3 0  13     747\n"
+  "6 1  14     310\n",
+
+  "@nodes\n"
+  "label\n"
+  "0\n"
+  "1\n"
+  "2\n"
+  "3\n"
+  "4\n"
+  "5\n"
+  "6\n"
+  "7\n"
+  "@edges\n"
+  "     label  weight\n"
+  "2 5  0      710\n"
+  "0 5  1      241\n"
+  "2 4  2      856\n"
+  "2 6  3      762\n"
+  "4 1  4      747\n"
+  "6 1  5      962\n"
+  "4 7  6      723\n"
+  "1 7  7      661\n"
+  "2 3  8      376\n"
+  "1 0  9      416\n"
+  "6 7  10     391\n",
+
+  "@nodes\n"
+  "label\n"
+  "0\n"
+  "1\n"
+  "2\n"
+  "3\n"
+  "4\n"
+  "5\n"
+  "6\n"
+  "7\n"
+  "@edges\n"
+  "     label  weight\n"
+  "6 2  0      553\n"
+  "0 7  1      653\n"
+  "6 3  2      22\n"
+  "4 7  3      846\n"
+  "7 2  4      981\n"
+  "7 6  5      250\n"
+  "5 2  6      539\n",
+};
+
+void checkMatching(const SmartGraph& graph,
+                   const MaxMatching<SmartGraph>& mm) {
+  int num = 0;
+
+  IntNodeMap comp_index(graph);
+  UnionFind<IntNodeMap> comp(comp_index);
+
+  int barrier_num = 0;
+
+  for (NodeIt n(graph); n != INVALID; ++n) {
+    check(mm.decomposition(n) == MaxMatching<SmartGraph>::EVEN ||
+          mm.matching(n) != INVALID, "Wrong Gallai-Edmonds decomposition");
+    if (mm.decomposition(n) == MaxMatching<SmartGraph>::ODD) {
+      ++barrier_num;
+    } else {
+      comp.insert(n);
+    }
+  }
+
+  for (EdgeIt e(graph); e != INVALID; ++e) {
+    if (mm.matching(e)) {
+      check(e == mm.matching(graph.u(e)), "Wrong matching");
+      check(e == mm.matching(graph.v(e)), "Wrong matching");
+      ++num;
+    }
+    check(mm.decomposition(graph.u(e)) != MaxMatching<SmartGraph>::EVEN ||
+          mm.decomposition(graph.v(e)) != MaxMatching<SmartGraph>::MATCHED,
+          "Wrong Gallai-Edmonds decomposition");
+
+    check(mm.decomposition(graph.v(e)) != MaxMatching<SmartGraph>::EVEN ||
+          mm.decomposition(graph.u(e)) != MaxMatching<SmartGraph>::MATCHED,
+          "Wrong Gallai-Edmonds decomposition");
+
+    if (mm.decomposition(graph.u(e)) != MaxMatching<SmartGraph>::ODD &&
+        mm.decomposition(graph.v(e)) != MaxMatching<SmartGraph>::ODD) {
+      comp.join(graph.u(e), graph.v(e));
+    }
+  }
+
+  std::set<int> comp_root;
+  int odd_comp_num = 0;
+  for (NodeIt n(graph); n != INVALID; ++n) {
+    if (mm.decomposition(n) != MaxMatching<SmartGraph>::ODD) {
+      int root = comp.find(n);
+      if (comp_root.find(root) == comp_root.end()) {
+        comp_root.insert(root);
+        if (comp.size(n) % 2 == 1) {
+          ++odd_comp_num;
+        }
+      }
+    }
+  }
+
+  check(mm.matchingSize() == num, "Wrong matching");
+  check(2 * num == countNodes(graph) - (odd_comp_num - barrier_num),
+         "Wrong matching");
+  return;
+}
+
+void checkWeightedMatching(const SmartGraph& graph,
+                   const SmartGraph::EdgeMap<int>& weight,
+                   const MaxWeightedMatching<SmartGraph>& mwm) {
+  for (SmartGraph::EdgeIt e(graph); e != INVALID; ++e) {
+    if (graph.u(e) == graph.v(e)) continue;
+    int rw = mwm.nodeValue(graph.u(e)) + mwm.nodeValue(graph.v(e));
+
+    for (int i = 0; i < mwm.blossomNum(); ++i) {
+      bool s = false, t = false;
+      for (MaxWeightedMatching<SmartGraph>::BlossomIt n(mwm, i);
+           n != INVALID; ++n) {
+        if (graph.u(e) == n) s = true;
+        if (graph.v(e) == n) t = true;
+      }
+      if (s == true && t == true) {
+        rw += mwm.blossomValue(i);
+      }
+    }
+    rw -= weight[e] * mwm.dualScale;
+
+    check(rw >= 0, "Negative reduced weight");
+    check(rw == 0 || !mwm.matching(e),
+          "Non-zero reduced weight on matching edge");
+  }
+
+  int pv = 0;
+  for (SmartGraph::NodeIt n(graph); n != INVALID; ++n) {
+    if (mwm.matching(n) != INVALID) {
+      check(mwm.nodeValue(n) >= 0, "Invalid node value");
+      pv += weight[mwm.matching(n)];
+      SmartGraph::Node o = graph.target(mwm.matching(n));
+      check(mwm.mate(n) == o, "Invalid matching");
+      check(mwm.matching(n) == graph.oppositeArc(mwm.matching(o)),
+            "Invalid matching");
+    } else {
+      check(mwm.mate(n) == INVALID, "Invalid matching");
+      check(mwm.nodeValue(n) == 0, "Invalid matching");
+    }
+  }
+
+  int dv = 0;
+  for (SmartGraph::NodeIt n(graph); n != INVALID; ++n) {
+    dv += mwm.nodeValue(n);
+  }
+
+  for (int i = 0; i < mwm.blossomNum(); ++i) {
+    check(mwm.blossomValue(i) >= 0, "Invalid blossom value");
+    check(mwm.blossomSize(i) % 2 == 1, "Even blossom size");
+    dv += mwm.blossomValue(i) * ((mwm.blossomSize(i) - 1) / 2);
+  }
+
+  check(pv * mwm.dualScale == dv * 2, "Wrong duality");
+
+  return;
+}
+
+void checkWeightedPerfectMatching(const SmartGraph& graph,
+                          const SmartGraph::EdgeMap<int>& weight,
+                          const MaxWeightedPerfectMatching<SmartGraph>& mwpm) {
+  for (SmartGraph::EdgeIt e(graph); e != INVALID; ++e) {
+    if (graph.u(e) == graph.v(e)) continue;
+    int rw = mwpm.nodeValue(graph.u(e)) + mwpm.nodeValue(graph.v(e));
+
+    for (int i = 0; i < mwpm.blossomNum(); ++i) {
+      bool s = false, t = false;
+      for (MaxWeightedPerfectMatching<SmartGraph>::BlossomIt n(mwpm, i);
+           n != INVALID; ++n) {
+        if (graph.u(e) == n) s = true;
+        if (graph.v(e) == n) t = true;
+      }
+      if (s == true && t == true) {
+        rw += mwpm.blossomValue(i);
+      }
+    }
+    rw -= weight[e] * mwpm.dualScale;
+
+    check(rw >= 0, "Negative reduced weight");
+    check(rw == 0 || !mwpm.matching(e),
+          "Non-zero reduced weight on matching edge");
+  }
+
+  int pv = 0;
+  for (SmartGraph::NodeIt n(graph); n != INVALID; ++n) {
+    check(mwpm.matching(n) != INVALID, "Non perfect");
+    pv += weight[mwpm.matching(n)];
+    SmartGraph::Node o = graph.target(mwpm.matching(n));
+    check(mwpm.mate(n) == o, "Invalid matching");
+    check(mwpm.matching(n) == graph.oppositeArc(mwpm.matching(o)),
+          "Invalid matching");
+  }
+
+  int dv = 0;
+  for (SmartGraph::NodeIt n(graph); n != INVALID; ++n) {
+    dv += mwpm.nodeValue(n);
+  }
+
+  for (int i = 0; i < mwpm.blossomNum(); ++i) {
+    check(mwpm.blossomValue(i) >= 0, "Invalid blossom value");
+    check(mwpm.blossomSize(i) % 2 == 1, "Even blossom size");
+    dv += mwpm.blossomValue(i) * ((mwpm.blossomSize(i) - 1) / 2);
+  }
+
+  check(pv * mwpm.dualScale == dv * 2, "Wrong duality");
+
+  return;
+}
+
+
+int main() {
+
+  for (int i = 0; i < lgfn; ++i) {
+    SmartGraph graph;
+    SmartGraph::EdgeMap<int> weight(graph);
+
+    istringstream lgfs(lgf[i]);
+    graphReader(graph, lgfs).
+      edgeMap("weight", weight).run();
+
+    MaxMatching<SmartGraph> mm(graph);
+    mm.run();
+    checkMatching(graph, mm);
+
+    MaxWeightedMatching<SmartGraph> mwm(graph, weight);
+    mwm.run();
+    checkWeightedMatching(graph, weight, mwm);
+
+    MaxWeightedPerfectMatching<SmartGraph> mwpm(graph, weight);
+    bool perfect = mwpm.run();
+
+    check(perfect == (mm.matchingSize() * 2 == countNodes(graph)),
+          "Perfect matching found");
+
+    if (perfect) {
+      checkWeightedPerfectMatching(graph, weight, mwpm);
+    }
+  }
+
+  return 0;
+}
Index: test/min_cost_flow_test.cc
===================================================================
--- test/min_cost_flow_test.cc	(revision 601)
+++ test/min_cost_flow_test.cc	(revision 601)
@@ -0,0 +1,455 @@
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library.
+ *
+ * Copyright (C) 2003-2009
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#include <iostream>
+#include <fstream>
+
+#include <lemon/list_graph.h>
+#include <lemon/smart_graph.h>
+#include <lemon/lgf_reader.h>
+
+//#include <lemon/cycle_canceling.h>
+//#include <lemon/capacity_scaling.h>
+//#include <lemon/cost_scaling.h>
+#include <lemon/network_simplex.h>
+//#include <lemon/min_cost_flow.h>
+//#include <lemon/min_cost_max_flow.h>
+
+#include <lemon/concepts/digraph.h>
+#include <lemon/concept_check.h>
+
+#include "test_tools.h"
+
+using namespace lemon;
+
+char test_lgf[] =
+  "@nodes\n"
+  "label  sup1 sup2 sup3\n"
+  "    1    20   27    0\n"
+  "    2    -4    0    0\n"
+  "    3     0    0    0\n"
+  "    4     0    0    0\n"
+  "    5     9    0    0\n"
+  "    6    -6    0    0\n"
+  "    7     0    0    0\n"
+  "    8     0    0    0\n"
+  "    9     3    0    0\n"
+  "   10    -2    0    0\n"
+  "   11     0    0    0\n"
+  "   12   -20  -27    0\n"
+  "\n"
+  "@arcs\n"
+  "       cost  cap low1 low2\n"
+  " 1  2    70   11    0    8\n"
+  " 1  3   150    3    0    1\n"
+  " 1  4    80   15    0    2\n"
+  " 2  8    80   12    0    0\n"
+  " 3  5   140    5    0    3\n"
+  " 4  6    60   10    0    1\n"
+  " 4  7    80    2    0    0\n"
+  " 4  8   110    3    0    0\n"
+  " 5  7    60   14    0    0\n"
+  " 5 11   120   12    0    0\n"
+  " 6  3     0    3    0    0\n"
+  " 6  9   140    4    0    0\n"
+  " 6 10    90    8    0    0\n"
+  " 7  1    30    5    0    0\n"
+  " 8 12    60   16    0    4\n"
+  " 9 12    50    6    0    0\n"
+  "10 12    70   13    0    5\n"
+  "10  2   100    7    0    0\n"
+  "10  7    60   10    0    0\n"
+  "11 10    20   14    0    6\n"
+  "12 11    30   10    0    0\n"
+  "\n"
+  "@attributes\n"
+  "source 1\n"
+  "target 12\n";
+
+
+// Check the interface of an MCF algorithm
+template <typename GR, typename Value>
+class McfClassConcept
+{
+public:
+
+  template <typename MCF>
+  struct Constraints {
+    void constraints() {
+      checkConcept<concepts::Digraph, GR>();
+
+      MCF mcf_test1(g, lower, upper, cost, sup);
+      MCF mcf_test2(g, upper, cost, sup);
+      MCF mcf_test3(g, lower, upper, cost, n, n, k);
+      MCF mcf_test4(g, upper, cost, n, n, k);
+
+      // TODO: This part should be enabled and the next part
+      // should be removed if map copying is supported
+/*
+      flow = mcf_test1.flowMap();
+      mcf_test1.flowMap(flow);
+
+      pot = mcf_test1.potentialMap();
+      mcf_test1.potentialMap(pot);
+*/
+/**/
+      const typename MCF::FlowMap &fm =
+        mcf_test1.flowMap();
+      mcf_test1.flowMap(flow);
+      const typename MCF::PotentialMap &pm =
+        mcf_test1.potentialMap();
+      mcf_test1.potentialMap(pot);
+      ignore_unused_variable_warning(fm);
+      ignore_unused_variable_warning(pm);
+/**/
+
+      mcf_test1.run();
+
+      v = mcf_test1.totalCost();
+      v = mcf_test1.flow(a);
+      v = mcf_test1.potential(n);
+    }
+
+    typedef typename GR::Node Node;
+    typedef typename GR::Arc Arc;
+    typedef concepts::ReadMap<Node, Value> NM;
+    typedef concepts::ReadMap<Arc, Value> AM;
+
+    const GR &g;
+    const AM &lower;
+    const AM &upper;
+    const AM &cost;
+    const NM &sup;
+    const Node &n;
+    const Arc &a;
+    const Value &k;
+    Value v;
+
+    typename MCF::FlowMap &flow;
+    typename MCF::PotentialMap &pot;
+  };
+
+};
+
+
+// Check the feasibility of the given flow (primal soluiton)
+template < typename GR, typename LM, typename UM,
+           typename SM, typename FM >
+bool checkFlow( const GR& gr, const LM& lower, const UM& upper,
+                const SM& supply, const FM& flow )
+{
+  TEMPLATE_DIGRAPH_TYPEDEFS(GR);
+
+  for (ArcIt e(gr); e != INVALID; ++e) {
+    if (flow[e] < lower[e] || flow[e] > upper[e]) return false;
+  }
+
+  for (NodeIt n(gr); n != INVALID; ++n) {
+    typename SM::Value sum = 0;
+    for (OutArcIt e(gr, n); e != INVALID; ++e)
+      sum += flow[e];
+    for (InArcIt e(gr, n); e != INVALID; ++e)
+      sum -= flow[e];
+    if (sum != supply[n]) return false;
+  }
+
+  return true;
+}
+
+// Check the feasibility of the given potentials (dual soluiton)
+// using the Complementary Slackness optimality condition
+template < typename GR, typename LM, typename UM,
+           typename CM, typename FM, typename PM >
+bool checkPotential( const GR& gr, const LM& lower, const UM& upper,
+                     const CM& cost, const FM& flow, const PM& pi )
+{
+  TEMPLATE_DIGRAPH_TYPEDEFS(GR);
+
+  bool opt = true;
+  for (ArcIt e(gr); opt && e != INVALID; ++e) {
+    typename CM::Value red_cost =
+      cost[e] + pi[gr.source(e)] - pi[gr.target(e)];
+    opt = red_cost == 0 ||
+          (red_cost > 0 && flow[e] == lower[e]) ||
+          (red_cost < 0 && flow[e] == upper[e]);
+  }
+  return opt;
+}
+
+// Run a minimum cost flow algorithm and check the results
+template < typename MCF, typename GR,
+           typename LM, typename UM,
+           typename CM, typename SM >
+void checkMcf( const MCF& mcf, bool mcf_result,
+               const GR& gr, const LM& lower, const UM& upper,
+               const CM& cost, const SM& supply,
+               bool result, typename CM::Value total,
+               const std::string &test_id = "" )
+{
+  check(mcf_result == result, "Wrong result " + test_id);
+  if (result) {
+    check(checkFlow(gr, lower, upper, supply, mcf.flowMap()),
+          "The flow is not feasible " + test_id);
+    check(mcf.totalCost() == total, "The flow is not optimal " + test_id);
+    check(checkPotential(gr, lower, upper, cost, mcf.flowMap(),
+                         mcf.potentialMap()),
+          "Wrong potentials " + test_id);
+  }
+}
+
+int main()
+{
+  // Check the interfaces
+  {
+    typedef int Value;
+    // This typedef should be enabled if the standard maps are
+    // reference maps in the graph concepts
+    //typedef concepts::Digraph GR;
+    typedef ListDigraph GR;
+    typedef concepts::ReadMap<GR::Node, Value> NM;
+    typedef concepts::ReadMap<GR::Arc, Value> AM;
+
+    //checkConcept< McfClassConcept<GR, Value>,
+    //              CycleCanceling<GR, AM, AM, AM, NM> >();
+    //checkConcept< McfClassConcept<GR, Value>,
+    //              CapacityScaling<GR, AM, AM, AM, NM> >();
+    //checkConcept< McfClassConcept<GR, Value>,
+    //              CostScaling<GR, AM, AM, AM, NM> >();
+    checkConcept< McfClassConcept<GR, Value>,
+                  NetworkSimplex<GR, AM, AM, AM, NM> >();
+    //checkConcept< MinCostFlow<GR, Value>,
+    //              NetworkSimplex<GR, AM, AM, AM, NM> >();
+  }
+
+  // Run various MCF tests
+  typedef ListDigraph Digraph;
+  DIGRAPH_TYPEDEFS(ListDigraph);
+
+  // Read the test digraph
+  Digraph gr;
+  Digraph::ArcMap<int> c(gr), l1(gr), l2(gr), u(gr);
+  Digraph::NodeMap<int> s1(gr), s2(gr), s3(gr);
+  Node v, w;
+
+  std::istringstream input(test_lgf);
+  DigraphReader<Digraph>(gr, input)
+    .arcMap("cost", c)
+    .arcMap("cap", u)
+    .arcMap("low1", l1)
+    .arcMap("low2", l2)
+    .nodeMap("sup1", s1)
+    .nodeMap("sup2", s2)
+    .nodeMap("sup3", s3)
+    .node("source", v)
+    .node("target", w)
+    .run();
+
+/*
+  // A. Test CapacityScaling with scaling
+  {
+    CapacityScaling<Digraph> mcf1(gr, u, c, s1);
+    CapacityScaling<Digraph> mcf2(gr, u, c, v, w, 27);
+    CapacityScaling<Digraph> mcf3(gr, u, c, s3);
+    CapacityScaling<Digraph> mcf4(gr, l2, u, c, s1);
+    CapacityScaling<Digraph> mcf5(gr, l2, u, c, v, w, 27);
+    CapacityScaling<Digraph> mcf6(gr, l2, u, c, s3);
+
+    checkMcf(mcf1, mcf1.run(), gr, l1, u, c, s1, true,  5240, "#A1");
+    checkMcf(mcf2, mcf2.run(), gr, l1, u, c, s2, true,  7620, "#A2");
+    checkMcf(mcf3, mcf3.run(), gr, l1, u, c, s3, true,     0, "#A3");
+    checkMcf(mcf4, mcf4.run(), gr, l2, u, c, s1, true,  5970, "#A4");
+    checkMcf(mcf5, mcf5.run(), gr, l2, u, c, s2, true,  8010, "#A5");
+    checkMcf(mcf6, mcf6.run(), gr, l2, u, c, s3, false,    0, "#A6");
+  }
+
+  // B. Test CapacityScaling without scaling
+  {
+    CapacityScaling<Digraph> mcf1(gr, u, c, s1);
+    CapacityScaling<Digraph> mcf2(gr, u, c, v, w, 27);
+    CapacityScaling<Digraph> mcf3(gr, u, c, s3);
+    CapacityScaling<Digraph> mcf4(gr, l2, u, c, s1);
+    CapacityScaling<Digraph> mcf5(gr, l2, u, c, v, w, 27);
+    CapacityScaling<Digraph> mcf6(gr, l2, u, c, s3);
+
+    checkMcf(mcf1, mcf1.run(false), gr, l1, u, c, s1, true,  5240, "#B1");
+    checkMcf(mcf2, mcf2.run(false), gr, l1, u, c, s2, true,  7620, "#B2");
+    checkMcf(mcf3, mcf3.run(false), gr, l1, u, c, s3, true,     0, "#B3");
+    checkMcf(mcf4, mcf4.run(false), gr, l2, u, c, s1, true,  5970, "#B4");
+    checkMcf(mcf5, mcf5.run(false), gr, l2, u, c, s2, true,  8010, "#B5");
+    checkMcf(mcf6, mcf6.run(false), gr, l2, u, c, s3, false,    0, "#B6");
+  }
+
+  // C. Test CostScaling using partial augment-relabel method
+  {
+    CostScaling<Digraph> mcf1(gr, u, c, s1);
+    CostScaling<Digraph> mcf2(gr, u, c, v, w, 27);
+    CostScaling<Digraph> mcf3(gr, u, c, s3);
+    CostScaling<Digraph> mcf4(gr, l2, u, c, s1);
+    CostScaling<Digraph> mcf5(gr, l2, u, c, v, w, 27);
+    CostScaling<Digraph> mcf6(gr, l2, u, c, s3);
+
+    checkMcf(mcf1, mcf1.run(), gr, l1, u, c, s1, true,  5240, "#C1");
+    checkMcf(mcf2, mcf2.run(), gr, l1, u, c, s2, true,  7620, "#C2");
+    checkMcf(mcf3, mcf3.run(), gr, l1, u, c, s3, true,     0, "#C3");
+    checkMcf(mcf4, mcf4.run(), gr, l2, u, c, s1, true,  5970, "#C4");
+    checkMcf(mcf5, mcf5.run(), gr, l2, u, c, s2, true,  8010, "#C5");
+    checkMcf(mcf6, mcf6.run(), gr, l2, u, c, s3, false,    0, "#C6");
+  }
+
+  // D. Test CostScaling using push-relabel method
+  {
+    CostScaling<Digraph> mcf1(gr, u, c, s1);
+    CostScaling<Digraph> mcf2(gr, u, c, v, w, 27);
+    CostScaling<Digraph> mcf3(gr, u, c, s3);
+    CostScaling<Digraph> mcf4(gr, l2, u, c, s1);
+    CostScaling<Digraph> mcf5(gr, l2, u, c, v, w, 27);
+    CostScaling<Digraph> mcf6(gr, l2, u, c, s3);
+
+    checkMcf(mcf1, mcf1.run(false), gr, l1, u, c, s1, true,  5240, "#D1");
+    checkMcf(mcf2, mcf2.run(false), gr, l1, u, c, s2, true,  7620, "#D2");
+    checkMcf(mcf3, mcf3.run(false), gr, l1, u, c, s3, true,     0, "#D3");
+    checkMcf(mcf4, mcf4.run(false), gr, l2, u, c, s1, true,  5970, "#D4");
+    checkMcf(mcf5, mcf5.run(false), gr, l2, u, c, s2, true,  8010, "#D5");
+    checkMcf(mcf6, mcf6.run(false), gr, l2, u, c, s3, false,    0, "#D6");
+  }
+*/
+
+  // E. Test NetworkSimplex with FIRST_ELIGIBLE_PIVOT
+  {
+    NetworkSimplex<Digraph>::PivotRuleEnum pr =
+      NetworkSimplex<Digraph>::FIRST_ELIGIBLE_PIVOT;
+    NetworkSimplex<Digraph> mcf1(gr, u, c, s1);
+    NetworkSimplex<Digraph> mcf2(gr, u, c, v, w, 27);
+    NetworkSimplex<Digraph> mcf3(gr, u, c, s3);
+    NetworkSimplex<Digraph> mcf4(gr, l2, u, c, s1);
+    NetworkSimplex<Digraph> mcf5(gr, l2, u, c, v, w, 27);
+    NetworkSimplex<Digraph> mcf6(gr, l2, u, c, s3);
+
+    checkMcf(mcf1, mcf1.run(pr), gr, l1, u, c, s1, true,  5240, "#E1");
+    checkMcf(mcf2, mcf2.run(pr), gr, l1, u, c, s2, true,  7620, "#E2");
+    checkMcf(mcf3, mcf3.run(pr), gr, l1, u, c, s3, true,     0, "#E3");
+    checkMcf(mcf4, mcf4.run(pr), gr, l2, u, c, s1, true,  5970, "#E4");
+    checkMcf(mcf5, mcf5.run(pr), gr, l2, u, c, s2, true,  8010, "#E5");
+    checkMcf(mcf6, mcf6.run(pr), gr, l2, u, c, s3, false,    0, "#E6");
+  }
+
+  // F. Test NetworkSimplex with BEST_ELIGIBLE_PIVOT
+  {
+    NetworkSimplex<Digraph>::PivotRuleEnum pr =
+      NetworkSimplex<Digraph>::BEST_ELIGIBLE_PIVOT;
+    NetworkSimplex<Digraph> mcf1(gr, u, c, s1);
+    NetworkSimplex<Digraph> mcf2(gr, u, c, v, w, 27);
+    NetworkSimplex<Digraph> mcf3(gr, u, c, s3);
+    NetworkSimplex<Digraph> mcf4(gr, l2, u, c, s1);
+    NetworkSimplex<Digraph> mcf5(gr, l2, u, c, v, w, 27);
+    NetworkSimplex<Digraph> mcf6(gr, l2, u, c, s3);
+
+    checkMcf(mcf1, mcf1.run(pr), gr, l1, u, c, s1, true,  5240, "#F1");
+    checkMcf(mcf2, mcf2.run(pr), gr, l1, u, c, s2, true,  7620, "#F2");
+    checkMcf(mcf3, mcf3.run(pr), gr, l1, u, c, s3, true,     0, "#F3");
+    checkMcf(mcf4, mcf4.run(pr), gr, l2, u, c, s1, true,  5970, "#F4");
+    checkMcf(mcf5, mcf5.run(pr), gr, l2, u, c, s2, true,  8010, "#F5");
+    checkMcf(mcf6, mcf6.run(pr), gr, l2, u, c, s3, false,    0, "#F6");
+  }
+
+  // G. Test NetworkSimplex with BLOCK_SEARCH_PIVOT
+  {
+    NetworkSimplex<Digraph>::PivotRuleEnum pr =
+      NetworkSimplex<Digraph>::BLOCK_SEARCH_PIVOT;
+    NetworkSimplex<Digraph> mcf1(gr, u, c, s1);
+    NetworkSimplex<Digraph> mcf2(gr, u, c, v, w, 27);
+    NetworkSimplex<Digraph> mcf3(gr, u, c, s3);
+    NetworkSimplex<Digraph> mcf4(gr, l2, u, c, s1);
+    NetworkSimplex<Digraph> mcf5(gr, l2, u, c, v, w, 27);
+    NetworkSimplex<Digraph> mcf6(gr, l2, u, c, s3);
+
+    checkMcf(mcf1, mcf1.run(pr), gr, l1, u, c, s1, true,  5240, "#G1");
+    checkMcf(mcf2, mcf2.run(pr), gr, l1, u, c, s2, true,  7620, "#G2");
+    checkMcf(mcf3, mcf3.run(pr), gr, l1, u, c, s3, true,     0, "#G3");
+    checkMcf(mcf4, mcf4.run(pr), gr, l2, u, c, s1, true,  5970, "#G4");
+    checkMcf(mcf5, mcf5.run(pr), gr, l2, u, c, s2, true,  8010, "#G5");
+    checkMcf(mcf6, mcf6.run(pr), gr, l2, u, c, s3, false,    0, "#G6");
+  }
+
+  // H. Test NetworkSimplex with CANDIDATE_LIST_PIVOT
+  {
+    NetworkSimplex<Digraph>::PivotRuleEnum pr =
+      NetworkSimplex<Digraph>::CANDIDATE_LIST_PIVOT;
+    NetworkSimplex<Digraph> mcf1(gr, u, c, s1);
+    NetworkSimplex<Digraph> mcf2(gr, u, c, v, w, 27);
+    NetworkSimplex<Digraph> mcf3(gr, u, c, s3);
+    NetworkSimplex<Digraph> mcf4(gr, l2, u, c, s1);
+    NetworkSimplex<Digraph> mcf5(gr, l2, u, c, v, w, 27);
+    NetworkSimplex<Digraph> mcf6(gr, l2, u, c, s3);
+
+    checkMcf(mcf1, mcf1.run(pr), gr, l1, u, c, s1, true,  5240, "#H1");
+    checkMcf(mcf2, mcf2.run(pr), gr, l1, u, c, s2, true,  7620, "#H2");
+    checkMcf(mcf3, mcf3.run(pr), gr, l1, u, c, s3, true,     0, "#H3");
+    checkMcf(mcf4, mcf4.run(pr), gr, l2, u, c, s1, true,  5970, "#H4");
+    checkMcf(mcf5, mcf5.run(pr), gr, l2, u, c, s2, true,  8010, "#H5");
+    checkMcf(mcf6, mcf6.run(pr), gr, l2, u, c, s3, false,    0, "#H6");
+  }
+
+  // I. Test NetworkSimplex with ALTERING_LIST_PIVOT
+  {
+    NetworkSimplex<Digraph>::PivotRuleEnum pr =
+      NetworkSimplex<Digraph>::ALTERING_LIST_PIVOT;
+    NetworkSimplex<Digraph> mcf1(gr, u, c, s1);
+    NetworkSimplex<Digraph> mcf2(gr, u, c, v, w, 27);
+    NetworkSimplex<Digraph> mcf3(gr, u, c, s3);
+    NetworkSimplex<Digraph> mcf4(gr, l2, u, c, s1);
+    NetworkSimplex<Digraph> mcf5(gr, l2, u, c, v, w, 27);
+    NetworkSimplex<Digraph> mcf6(gr, l2, u, c, s3);
+
+    checkMcf(mcf1, mcf1.run(pr), gr, l1, u, c, s1, true,  5240, "#I1");
+    checkMcf(mcf2, mcf2.run(pr), gr, l1, u, c, s2, true,  7620, "#I2");
+    checkMcf(mcf3, mcf3.run(pr), gr, l1, u, c, s3, true,     0, "#I3");
+    checkMcf(mcf4, mcf4.run(pr), gr, l2, u, c, s1, true,  5970, "#I4");
+    checkMcf(mcf5, mcf5.run(pr), gr, l2, u, c, s2, true,  8010, "#I5");
+    checkMcf(mcf6, mcf6.run(pr), gr, l2, u, c, s3, false,    0, "#I6");
+  }
+
+/*
+  // J. Test MinCostFlow
+  {
+    MinCostFlow<Digraph> mcf1(gr, u, c, s1);
+    MinCostFlow<Digraph> mcf2(gr, u, c, v, w, 27);
+    MinCostFlow<Digraph> mcf3(gr, u, c, s3);
+    MinCostFlow<Digraph> mcf4(gr, l2, u, c, s1);
+    MinCostFlow<Digraph> mcf5(gr, l2, u, c, v, w, 27);
+    MinCostFlow<Digraph> mcf6(gr, l2, u, c, s3);
+
+    checkMcf(mcf1, mcf1.run(), gr, l1, u, c, s1, true,  5240, "#J1");
+    checkMcf(mcf2, mcf2.run(), gr, l1, u, c, s2, true,  7620, "#J2");
+    checkMcf(mcf3, mcf3.run(), gr, l1, u, c, s3, true,     0, "#J3");
+    checkMcf(mcf4, mcf4.run(), gr, l2, u, c, s1, true,  5970, "#J4");
+    checkMcf(mcf5, mcf5.run(), gr, l2, u, c, s2, true,  8010, "#J5");
+    checkMcf(mcf6, mcf6.run(), gr, l2, u, c, s3, false,    0, "#J6");
+  }
+*/
+/*
+  // K. Test MinCostMaxFlow
+  {
+    MinCostMaxFlow<Digraph> mcmf(gr, u, c, v, w);
+    mcmf.run();
+    checkMcf(mcmf, true, gr, l1, u, c, s3, true, 7620, "#K1");
+  }
+*/
+
+  return 0;
+}
Index: test/mip_test.cc
===================================================================
--- test/mip_test.cc	(revision 575)
+++ test/mip_test.cc	(revision 462)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2009
+ * Copyright (C) 2003-2008
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -19,4 +19,5 @@
 #include "test_tools.h"
 
+
 #ifdef HAVE_CONFIG_H
 #include <lemon/config.h>
@@ -29,8 +30,4 @@
 #ifdef HAVE_GLPK
 #include <lemon/glpk.h>
-#endif
-
-#ifdef HAVE_CBC
-#include <lemon/cbc.h>
 #endif
 
@@ -61,9 +58,10 @@
 void aTest(MipSolver& mip)
 {
-  //The following example is very simple
+ //The following example is very simple
 
 
   typedef MipSolver::Row Row;
   typedef MipSolver::Col Col;
+
 
 
@@ -77,4 +75,5 @@
   mip.max();
 
+
   //Unconstrained optimization
   mip.solve();
@@ -82,10 +81,9 @@
 
   //Constraints
-  mip.addRow(2 * x1 + x2 <= 2);
-  Row y2 = mip.addRow(x1 - 2 * x2 <= 0);
+  mip.addRow(2*x1+x2 <=2);
+  mip.addRow(x1-2*x2 <=0);
 
   //Nonnegativity of the variable x1
   mip.colLowerBound(x1, 0);
-
 
   //Maximization of x1
@@ -93,5 +91,4 @@
   double expected_opt=4.0/5.0;
   solveAndCheck(mip, MipSolver::OPTIMAL, expected_opt);
-
 
   //Restrict x2 to integer
@@ -106,24 +103,8 @@
   solveAndCheck(mip, MipSolver::OPTIMAL, expected_opt);
 
-  //Erase a variable
-  mip.erase(x2);
-  mip.rowUpperBound(y2, 8);
-  expected_opt=1;
-  solveAndCheck(mip, MipSolver::OPTIMAL, expected_opt);
+
 
 }
 
-
-template<class MIP>
-void cloneTest()
-{
-
-  MIP* mip = new MIP();
-  MIP* mipnew = mip->newSolver();
-  MIP* mipclone = mip->cloneSolver();
-  delete mip;
-  delete mipnew;
-  delete mipclone;
-}
 
 int main()
@@ -134,5 +115,4 @@
     GlpkMip mip1;
     aTest(mip1);
-    cloneTest<GlpkMip>();
   }
 #endif
@@ -142,15 +122,11 @@
     CplexMip mip2;
     aTest(mip2);
-    cloneTest<CplexMip>();
   } catch (CplexEnv::LicenseError& error) {
+#ifdef LEMON_FORCE_CPLEX_CHECK
     check(false, error.what());
-  }
+#else
+    std::cerr << error.what() << std::endl;
+    std::cerr << "Cplex license check failed, lp check skipped" << std::endl;
 #endif
-
-#ifdef HAVE_CBC
-  {
-    CbcMip mip1;
-    aTest(mip1);
-    cloneTest<CbcMip>();
   }
 #endif
Index: test/preflow_test.cc
===================================================================
--- test/preflow_test.cc	(revision 585)
+++ test/preflow_test.cc	(revision 440)
@@ -85,20 +85,16 @@
   FlowMap flow;
   CutMap cut;
-  VType v;
-  bool b;
-
-  typedef Preflow<Digraph, CapMap>
-            ::SetFlowMap<FlowMap>
-            ::SetElevator<Elev>
-            ::SetStandardElevator<LinkedElev>
-            ::Create PreflowType;
-  PreflowType preflow_test(g, cap, n, n);
-  const PreflowType& const_preflow_test = preflow_test;
-
-  preflow_test
-    .capacityMap(cap)
-    .flowMap(flow)
-    .source(n)
-    .target(n);
+
+  Preflow<Digraph, CapMap>
+    ::SetFlowMap<FlowMap>
+    ::SetElevator<Elev>
+    ::SetStandardElevator<LinkedElev>
+    ::Create preflow_test(g,cap,n,n);
+
+  preflow_test.capacityMap(cap);
+  flow = preflow_test.flowMap();
+  preflow_test.flowMap(flow);
+  preflow_test.source(n);
+  preflow_test.target(n);
 
   preflow_test.init();
@@ -109,11 +105,9 @@
   preflow_test.runMinCut();
 
-  v = const_preflow_test.flowValue();
-  v = const_preflow_test.flow(e);
-  const FlowMap& fm = const_preflow_test.flowMap();
-  b = const_preflow_test.minCut(n);
-  const_preflow_test.minCutMap(cut);
-  
-  ignore_unused_variable_warning(fm);
+  preflow_test.flowValue();
+  preflow_test.minCut(n);
+  preflow_test.minCutMap(cut);
+  preflow_test.flow(e);
+
 }
 
Index: test/time_measure_test.cc
===================================================================
--- test/time_measure_test.cc	(revision 558)
+++ test/time_measure_test.cc	(revision 440)
@@ -40,14 +40,16 @@
   Timer T;
   unsigned int n;
-  for(n=0;T.realTime()<0.1;n++) ;
+  for(n=0;T.realTime()<1.0;n++) ;
   std::cout << T << " (" << n << " time queries)\n";
-
+  T.restart();
+  while(T.realTime()<2.0) ;
+  std::cout << T << '\n';
   TimeStamp full;
   TimeStamp t;
-  t=runningTimeTest(f,0.1,&n,&full);
+  t=runningTimeTest(f,1,&n,&full);
   std::cout << t << " (" << n << " tests)\n";
   std::cout << "Total: " << full << "\n";
 
-  t=runningTimeTest(g,0.1,&n,&full);
+  t=runningTimeTest(g,1,&n,&full);
   std::cout << t << " (" << n << " tests)\n";
   std::cout << "Total: " << full << "\n";
Index: tools/CMakeLists.txt
===================================================================
--- tools/CMakeLists.txt	(revision 549)
+++ tools/CMakeLists.txt	(revision 527)
@@ -1,8 +1,8 @@
 INCLUDE_DIRECTORIES(
-  ${PROJECT_SOURCE_DIR}
-  ${PROJECT_BINARY_DIR}
+  ${CMAKE_SOURCE_DIR}
+  ${CMAKE_BINARY_DIR}
 )
 
-LINK_DIRECTORIES(${PROJECT_BINARY_DIR}/lemon)
+LINK_DIRECTORIES(${CMAKE_BINARY_DIR}/lemon)
 
 ADD_EXECUTABLE(lgf-gen lgf-gen.cc)
@@ -23,6 +23,6 @@
 IF(NOT WIN32)
   INSTALL(
-    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/lemon-0.x-to-1.x.sh
-    DESTINATION bin
+    FILES ${CMAKE_CURRENT_SOURCE_DIR}/lemon-0.x-to-1.x.sh
+    RUNTIME DESTINATION bin
     COMPONENT bin)
 ENDIF(NOT WIN32)
